{% extends 'base.html' %}

{% load static %}
{% block content %}
<script src="{% static '/two_factor_authentication/js/two_factor_auth.js' %}"></script>
	<div class="row prepend-top-default p-2">
		<div class="col-lg-4 profile-settings-sidebar">
			<h4 class="prepend-top-0"><strong>Register Two-Factor Authenticator</strong></h4>
			<p>Use an one time password authenticator on your mobile device or computer to enable two-factor authentication (2FA)</p>
		</div>
		<div class="col-lg-8">
			{% if messages %}
				<div class="{{ message.tags}} {{ message.extra_tags }}">
					{% for message in messages %}
						<div class="alert alert-success" role="alert">{{ message }}</div>
					{% endfor %}
				</div>
				<p>
					Should you ever lose your phone or access to your one time password secret, each of these recovery codes can be used one time each to regain access to your account. Please save them in a safe place, or you will lose access to your account
				</p>
            {% endif %}
			{% if enabled and not messages %}
			<p>
				You've already enabled two-factor authentication using one time password authenticators. In order to register a different device, you must first disable two-factor authentication.
			</p>
			<p>
				If you lose your device you can change the recovery method for sign-in.
			</p>
			{% elif not enabled %}
				<p>
					Install a soft token authenticator like <a href="https://freeotp.github.io/">FreeOTP</a> or Google Authenticator from your application repository and use that app to scan this QR code. More information is available in the <a href="/help/user/profile/account/two_factor_authentication" target="_blank">documentation</a>.
				</p>
			{% endif %}
			<div class="row">
				{% if not enabled %}
					<div class="col-md-4">
						<img width="220" height="220" src='{% url "two_factor_authentication:user_qrcode" deviceid=device_id %}' onerror="document.getElementById('qrcode').style.display = 'none'; document.getElementById('no-qrcode').style.display = 'block';">
					</div>
					<div class="col-md-8">
						<div class="account-well">
							<p class="prepend-top-0 append-bottom-0">
							Can't scan the code?
							</p>
							<p class="prepend-top-0 append-bottom-0">
							To add the entry manually, provide the following details to the application on your phone.
							</p>
							<p class="prepend-top-0 append-bottom-0">
							Account: golearner:aj.inbusiness@gmail.com
							</p>
							<p class="prepend-top-0 append-bottom-0">
							Key: 7mm7 ghtu nwbt hnz2 of2h rmvb 7vpq e7ui
							</p>
							<p class="two-factor-new-manual-content">
							Time based: Yes
							</p>
						</div>
					</div>
				{% else %}
				<div class="col-md-12">
					<a data-confirm="Are you sure? This will invalidate your registered applications and U2F devices." href="{% url 'two_factor_authentication:disable_two_factor' %}" class="btn btn-danger text-white disable-two-factor">Disable two-factor authentication</a>
					<a href="{% url 'two_factor_authentication:recovery_two_factor' %}" class="btn btn-default recovery-methods">Change Recovery Methods</a>
				</div>
				{% endif %}
			</div>
			{% if not enabled %}
				<form accept-charset="UTF-8" method="POST">
	                {% if form.pin_code.errors %}
	                  <div class="alert alert-danger">
	                      <a class="close" href="#" data-dismiss="alert">×</a>
	                      {{ form.pin_code.errors }}
	                  </div>
	                {% endif %}
					<div class="form-group">
						<label class="label-bold" for="pin_code">Enter the 6-digit code that you see in the app
						</label>
						<input type="text" name="{{ form.pin_code.html_name}}" id="{{ form.pin_code.id_for_label}}"  maxlength=6 value="" class="form-control form-control-md"  autofocus="autofocus" autocomplete="off" required />
					</div>
					<div class="pb-2"><strong>Select any one of the recovery option:</strong></div>
					{% for value, text in rc_form.recovery_method.field.choices %}
							<div class="custom-control custom-switch pb-2">
							{% if text is not None and value is not None %}
							  <input type="radio" class="custom-control-input" id="id_recovery_method_{{ forloop.counter }}" name="{{ rc_form.recovery_method.html_name}}" value="{{ value }}" required>
							  {% if value in "email" %}
							  	<label class="custom-control-label" for="id_recovery_method_{{ forloop.counter }}">Email address - <strong>{{ text }}</strong></label>
							  {% else %}
							  	<label class="custom-control-label" for="id_recovery_method_{{ forloop.counter }}">Mobile number - <strong>{{ text }}</strong></label>
							  {% endif %}
							{% else %}
								{% if value in "email" %}
									<label class="custom-control-label">Inorder to use email address as recovery methods, please <a href="">update email address.</a></label>
								{% else %}
									<label class="custom-control-label disabled">Inorder to use mobile number as recovery methods, please <a href="">update mobile number.</a></label>
								{% endif %}
							{% endif %}
							</div>
					{% endfor %}
					{{ rc_form.recovery_method.errors }}
					<p class="form-text text-muted hint">
						If you lose your device you can use any one of these methods to login.
					</p>
					<div class="prepend-top-default">
						<input type="submit" name="commit" value="Register with two-factor app" class="btn btn-success" data-disable-with="Register with two-factor app">
					</div>
					{% csrf_token %}
				</form>
			{% endif %}
		</div>
	</div>
	<hr>
	<div class="row pl-3 pt-2">
		<div class="col-lg-12">
			<p>
				Two-factor authentication (2FA), sometimes referred to as two-step verification or dual-factor authentication, is a security process in which users provide two different authentication factors to verify themselves. This process is done to better protect both the user's credentials and the resources the user can access. Two-factor authentication provides a higher level of security than authentication methods that depend on single-factor authentication (SFA), in which the user provides only one factor -- typically, a password or passcode. Two-factor authentication methods rely on a user providing a password, as well as a second factor, usually either a security token or a biometric factor, such as a fingerprint or facial scan.
			</p>
		</div>
	</div>
{% endblock %}